Redmine - Defect #4204

Failing test in test_show_atom
2009-11-12 05:51 - Eric Davis

Status: Closed Start date: 2009-11-12
Priority: Normal Due date:

Assignee: Eric Davis % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 0.9.4

Resolution: Fixed Affected version:

Description

(Pulling this out of the discussion from #3391)

I'm getting a failing test in the test_show_atom(IssuesControllerTest) but it's not reproducible by others

patch here.

. Going to try to work on a

Related issues:

Related to Redmine - Defect #3391: When reading RSS feed, the inline-embedded...

Closed

2009-05-20

Associated revisions

Revision 3033 - 2009-11-12 05:59 - Eric Davis
Adding the body of the feed to the failure message. #4204

Revision 3558 - 2010-03-10 06:38 - Eric Davis
Use assert_select to check the download link. (#4204)

History

#1 - 2009-11-12 06:00 - Eric Davis

Looks like an environment issue, since both the test and actual code are escaping quotes (img src=

# Test

<?xml version="1.0" encoding="UTF-8"7?>

<feed xmlns="http://www.w3.0rg/2005/Atom">
<title></title>

<link href="http://test.host/issues/2.atom" rel="self"/>

<link href="http://test.host/" rel="alternate"/>
<id>http://test.host/</id>
<updated>2009-11-10T00:00:00-08:00</updated>
<author>

<name>Redmine</name>
</author>
<entry>

")

<title>eCookbook - Feature request #2: Add ingredients categories</title>
<link href="http://test.host/issues/2" rel="alternate"/>

<id>http://test.host/issues/2?journal_id=3</id>
<updated>2009-11-10T00:00:00-08:00</updated>
<author>
<name>John Smith</name>
<email>jsmith@somenet.foo</email>
</author>
<content type="html">

&lt;ulsagt;&lt; /ul&gt; &lt;p&gt;A comment with inline image:
http://test.host/attachments/download/10&quot; alt=&quot;&quot;

</entry>
</feed>

Atom feed (displays the image properly):

<entry>

&1lt;img src=&quot;
/&gt; &lt; /p&gt; </

content>

<title>Digitized 24 hour firmware - Bug #398: Face to face fault-tolerant approach</title>
<link href="http://localhost:3000/issues/398" rel="alternate"/>
<id>http://localhost:3000/issues/398?journal_id=132</id>

<updated>2009-11-11T21:02:26-08:00</updated>
https://www.redmine.org/issues/3391

<author>
<name>Redmine Admin</name>
<email>edavis@littlestreamsoftware.com</email>
</author>
<content type="html">

&lt;ulsagt;&lt;lisgt; &1lt;strong&gt;File&lt; /strongs&gt; &lt;a href=&quot;/attachments/5/redmine-error.png

&quot; &gt;redmine-error.png&lt; /a&gt; addeds&lt;/li&gt;&lt; /uls&gt;&lt;p&gt; Test &lt;img src=&quot;

http://localhost:3000/attachments/download/5&quot; alt=&quot;&quot; /&gt;s&lt;/pé&gt; </content>
</entry>

#2 - 2009-11-12 06:13 - Eric Davis
This might be from Builder. I'm running 2.1.2 which includes this:
Version 2.0.0 introduces automatically escaped attribute values for the first time. Versions prior to 2.0.0 did not insert escape characters into

attribute values in the XML markup. This allowed attribute values to explicitly reference entities, which was occasionally used by a small number
of developers. Since strings could always be explicitly escaped by hand, this was not a major restriction in functionality.

However, it did suprise most users of builder. Since the body text is normally escaped, everybody expected the attribute values to be escaped as
well. Escaped attribute values were the number one support request on the 1.x Builder series.

Starting with Builder version 2.0.0, all attribute values expressed as strings will be processed and the appropriate characters will be escaped
(e.g. "&" will be tranlated to "&"). Attribute values that are expressed as Symbol values will not be processed for escaped characters and will be
unchanged in output. (Yes, this probably counts as Symbol abuse, but the convention is convenient and flexible).

From: http://builder.rubyforge.org/

Running this by hand, the textilized attributes are escaped:

>> xml = Builder::XmlMarkup.new

=> inspect

>> xml.text! textilizable (change, :notes, :only_path => false)

=> "<inspect/>&lt;pé&gt;Test &lt;img src=&quot;http://localhost:3000/attachments/download/5&quot; alt=&quot;&qu
ot; /&gt;&lt;/p&gt;"

| don't see any specific version of Builder required for Rails, so maybe we are running different versions which is causing the different output.
Jean-Philippe, what version of builder do you have?

#3 - 2009-11-12 22:48 - Jean-Philippe Lang

I'm using builder 2.1.2 too.

#4 - 2009-11-12 22:58 - Jean-Philippe Lang

Double quotes are not escaped:

irb (main) :001:0> require 'rubygems'

=> true

irb(main) :002:0> require 'builder'

=> true

irb(main) :003:0> xml = Builder::XmlMarkup.new

=> <inspect/>

irb(main) : 004:0> xml.text! '<img src="foo.png" />'
=> "<inspect/>&lt;img src=\"foo.png\" /&gt;"

Version:

gem list --local builder
**% LOCAL GEMS ***

builder (2.1.2)

#5 - 2010-03-10 06:39 - Eric Davis

- Status changed from 7 to Resolved
- Target version set to 0.9.4

- % Done changed from 0 to 100

- Resolution set to Fixed

Jean-Philippe Lang:
http://builder.rubyforge.org/

I'm still getting this error and have been since | reported this
Let me know if it doesn't work on your system.

#6 - 2010-04-11 16:05 - Jean-Philippe Lang

- Status changed from Resolved to Closed

It seems to be OK. Merged in 0.9-stable.

2025-05-17

. I've committed r3558 to try and use a different method of checking the atom response.
https://www.redmine.org/projects/redmine/repository/svn/revisions/3558
http://www.tcpdf.org

